/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/Users/lake/projects/peardeck-monolith/apps/chrome-extension/build/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/NewContentBadgeApp/NewContentBadgeApp.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/NewContentBadgeApp/NewContentBadgeApp.js":
/*!******************************************************!*\
  !*** ./src/NewContentBadgeApp/NewContentBadgeApp.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

/**
 * This "app" is in charge of displaying a badge in the extension
 * icon that indicates whether there is new content in the popup that
 * the user has not seen yet.
 *
 * This is done by storing a value in local storage that indicates
 * what the latest "content version" they have seen is. If the latest
 * version seen is less than the current version, we show the badge,
 * and when the popup is opened, we update the stored value to indicate
 * they have seen the latest version.
 */

/**
 * The lastest version of content.
 * Increment this if there has been a content update we want to notify the
 * user about.
 */
const CURRENT_CONTENT_VERSION = 3;

/**
 * The storage key to use for tracking the last version of content the user
 * has seen.
 */
const CONTENT_VERSION_KEY = "LastContentUpdateSeen";

/**
 * The text to display in the badge of the extension icon.
 */
const BADGE_TEXT = "1";

/**
 * The background color of the badge.
 */
const BADGE_COLOR = "#3087B7";

/**
 * Updates the badge visibility based on the content version the user
 * has seen.
 *
 * @param {Number} contentVersionSeen
 */
const updateBadgeVisibility = contentVersionSeen => {
  const showBadge = (contentVersionSeen || 0) < CURRENT_CONTENT_VERSION;
  chrome.browserAction.setBadgeBackgroundColor({ color: BADGE_COLOR });
  chrome.browserAction.setBadgeText({ text: showBadge ? BADGE_TEXT : "" });
};

chrome.storage.sync.get({ [CONTENT_VERSION_KEY]: 0 }, function(result) {
  updateBadgeVisibility(result[CONTENT_VERSION_KEY]);
});

chrome.storage.onChanged.addListener(function(changes, namespace) {
  if (changes[CONTENT_VERSION_KEY]) {
    updateBadgeVisibility(changes[CONTENT_VERSION_KEY].newValue);
  }
});

chrome.runtime.onMessage.addListener(function(message) {
  return new Promise(resolve => {
    // The popup sends a message when it is opened. If we recieved that message,
    // the user has seen the lates content, so update the preference value
    // accordingly. That will trigger the storage `onChanged` listener to actually
    // update the badge visibility.
    if (message.type && message.type == "PopupOpened") {
      chrome.storage.sync.set(
        { [CONTENT_VERSION_KEY]: CURRENT_CONTENT_VERSION },
        resolve
      );
    } else {
      resolve();
    }
  });
});


/***/ })

/******/ });
//# sourceMappingURL=NewContentBadgeApp.js.map